<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="标签名称" prop="labelName">
        <el-input v-model="queryParams.labelName" placeholder="请输入标签名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="标签分类" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择标签分类" @keyup.enter.native="handleQuery">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.DICT_BASE_LABEL_BUSI_TYPE)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="openForm(undefined)"
                   v-hasPermi="['base:label:create']">新增
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="标签名称" align="center" prop="labelName"/>
      <el-table-column label="标签样式" align="center" prop="labelType">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.DICT_BASE_LABEL_TYPE" :value="scope.row.labelType" />
        </template>
      </el-table-column>
      <el-table-column label="分类" align="center" prop="labelType">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.DICT_BASE_LABEL_BUSI_TYPE" :value="scope.row.type" />
        </template>
      </el-table-column>
      <el-table-column label="标签描述" align="center" prop="labelDesc"/>
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="openForm(scope.row.id)"
                     v-hasPermi="['base:label:update']">修改
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['base:label:delete']">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>
    <!-- 对话框(添加 / 修改) -->
    <LabelForm ref="formRef" @success="getList"/>
  </div>
</template>

<script>
import * as LabelApi from '@/api/base/label';
import LabelForm from './LabelForm.vue';

export default {
  name: "Label",
  components: {
    LabelForm,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 标签库列表
      list: [],
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 选中行
      currentRow: {},
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        labelName: null,
        type:null,
        labelDesc: null,
        systemCode: null,
        createTime: [],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    async getList() {
      try {
        this.loading = true;
        const res = await LabelApi.getLabelPage(this.queryParams);
        this.list = res.data.records;
        this.total = res.data.total;
      } finally {
        this.loading = false;
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 添加/修改操作 */
    openForm(id) {
      this.$refs["formRef"].open(id);
    },
    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id;
      await this.$modal.confirm('是否确认删除标签库编号为"' + id + '"的数据项?')
      try {
        await LabelApi.deleteLabel(id);
        await this.getList();
        this.$modal.msgSuccess("删除成功");
      } catch {
      }
    },
    /** 导出按钮操作 */
    async handleExport() {
      await this.$modal.confirm('是否确认导出所有标签库数据项?');
      try {
        this.exportLoading = true;
        const data = await LabelApi.exportLabelExcel(this.queryParams);
        this.$download.excel(data, '标签库.xls');
      } catch {
      } finally {
        this.exportLoading = false;
      }
    },
  }
};
</script>
